CVE-2022-31109 – laminas-diactoros is a PHP package containing implementations of the PSR-7 HTTP message in …

Vuln ID: CVE-2022-31109

Published:  2022-08-01  17:15:08Z

Description: laminas-diactoros is a PHP package containing implementations of the PSR-7 HTTP message interfaces and PSR-17 HTTP message factory interfaces. Applications that use Diactoros, and are either not behind a proxy, or can be accessed via untrusted proxies, can potentially have the host, protocol, and/or port of a `LaminasDiactorosUri` instance associated with the incoming server request modified to reflect values from `X-Forwarded-*` headers. Such changes can potentially lead to XSS attacks (if a fully-qualified URL is used in links) and/or URL poisoning. Since the `X-Forwarded-*` headers do have valid use cases, particularly in clustered environments using a load balancer, the library offers mitigation measures only in the v2 releases, as doing otherwise would break these use cases immediately. Users of v2 releases from 2.11.1 can provide an additional argument to `LaminasDiactorosServerRequestFactory::fromGlobals()` in the form of a `LaminasDiactorosRequestFilterRequestFilterInterface` instance, including the shipped `LaminasDiactorosRequestFilterNoOpRequestFilter` implementation which ignores the `X-Forwarded-*` headers. Starting in version 3.0, the library will reverse behavior to use the `NoOpRequestFilter` by default, and require users to opt-in to `X-Forwarded-*` header usage via a configured `LaminasDiactorosRequestFilterLegacyXForwardedHeaderFilter` instance. Users are advised to upgrade to version 2.11.1 or later to resolve this issue. Users unable to upgrade may configure web servers to reject `X-Forwarded-*` headers at the web server level.

Source: NVD.NIST.GOV